package testbidule;

import java.io.PrintWriter;
import java.io.StringWriter;
import java.util.Hashtable;
import java.util.Properties;

import org.eclipse.ecf.core.ContainerFactory;
import org.eclipse.ecf.core.IContainer;
import org.eclipse.ecf.core.identity.ID;
import org.eclipse.ecf.core.identity.IDFactory;
import org.eclipse.ecf.core.security.ConnectContextFactory;
import org.eclipse.ecf.core.security.IConnectContext;
import org.eclipse.ecf.core.util.ECFException;
import org.eclipse.ecf.presence.IPresence;
import org.eclipse.ecf.presence.IPresenceContainerAdapter;
import org.eclipse.ecf.presence.Presence;
import org.eclipse.ecf.presence.roster.IRosterManager;
import org.eclipse.ecf.remoteservice.Constants;
import org.eclipse.ecf.remoteservice.IRemoteCall;
import org.eclipse.ecf.remoteservice.IRemoteServiceContainerAdapter;
import org.eclipse.ecf.remoteservice.IRemoteServiceListener;
import org.eclipse.ecf.remoteservice.IRemoteServiceRegistration;
import org.eclipse.ecf.remoteservice.events.IRemoteServiceEvent;
import org.eclipse.ecf.remoteservice.util.RemoteServiceProperties;
import org.eclipse.jface.resource.JFaceResources;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Font;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Text;
import org.eclipse.ui.part.ViewPart;

import service.IConcatService;
import service.IConcatServiceImpl;


public class TryWindows extends ViewPart
{

    public static final String ID = "testBidule.tryWindows"; //$NON-NLS-1$

    private Text text, text1, textpwd1, text2, textpwd2, textcontainer;

    @Override
    public void createPartControl(Composite parent)
    {
        Composite top = new Composite(parent, SWT.NONE);
        GridLayout layout = new GridLayout();
        layout.marginHeight = 0;
        layout.marginWidth = 0;
        top.setLayout(layout);
        // top banner
        Composite banner = new Composite(top, SWT.NONE);
        banner.setLayoutData(new GridData(SWT.FILL,
        		SWT.FILL, true, false));
        layout = new GridLayout();
        layout.marginHeight = 5;
        layout.marginWidth = 10;
        layout.numColumns = 2;
        banner.setLayout(layout);

        // setup bold font
        Font boldFont = JFaceResources.getFontRegistry().getBold(
                JFaceResources.DEFAULT_FONT);

        Label lcontainer = new Label(banner, SWT.WRAP);
        lcontainer.setText("Container :"); //$NON-NLS-1$
        lcontainer.setFont(boldFont);

        textcontainer = new Text(banner, SWT.SINGLE | SWT.LEAD | SWT.BORDER);
        textcontainer
                .setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true));
        textcontainer.setText("ecf.xmpp.smack"); //$NON-NLS-1$

        Label l1 = new Label(banner, SWT.WRAP);
        l1.setText("First client :"); //$NON-NLS-1$
        l1.setFont(boldFont);

        text1 = new Text(banner, SWT.SINGLE | SWT.LEAD | SWT.BORDER);
        text1.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true));
        text1.setText("ecf.test1@myserver"); //$NON-NLS-1$

        Label lpwd1 = new Label(banner, SWT.WRAP);
        lpwd1.setText("Password first client :"); //$NON-NLS-1$
        lpwd1.setFont(boldFont);

        textpwd1 = new Text(banner, SWT.SINGLE | SWT.LEAD | SWT.BORDER);
        textpwd1.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true));
        textpwd1.setText("bot"); //$NON-NLS-1$

        Label l2 = new Label(banner, SWT.WRAP);
        l2.setText("Second client :"); //$NON-NLS-1$
        l2.setFont(boldFont);

        text2 = new Text(banner, SWT.SINGLE | SWT.LEAD | SWT.BORDER);
        text2.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true));
        text2.setText("ecf.test2@myserver"); //$NON-NLS-1$

        Label lpwd2 = new Label(banner, SWT.WRAP);
        lpwd2.setText("Password first client :"); //$NON-NLS-1$
        lpwd2.setFont(boldFont);

        textpwd2 = new Text(banner, SWT.SINGLE | SWT.LEAD | SWT.BORDER);
        textpwd2.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true));
        textpwd2.setText("bot"); //$NON-NLS-1$

        Button button = new Button(banner, SWT.PUSH);
        button.setLayoutData(new GridData(SWT.BEGINNING, SWT.CENTER, false,
                false));
        button.setText("Run 1"); //$NON-NLS-1$
        button.addSelectionListener(new SelectionAdapter()
        {
            @Override
            public void widgetSelected(SelectionEvent e)
            {
                LaunchThread1 lch1 = new LaunchThread1(textcontainer.getText(),
                        text1.getText(), textpwd1.getText(), text2.getText());
                Thread t = new Thread(lch1);
                t.start();
            }
        });

        Button button2 = new Button(banner, SWT.PUSH);
        button2.setLayoutData(new GridData(SWT.BEGINNING, SWT.CENTER, false,
                false));
        button2.setText("Run 2"); //$NON-NLS-1$
        button2.addSelectionListener(new SelectionAdapter()
        {
            @Override
            public void widgetSelected(SelectionEvent e)
            {
                LaunchThread2 lch1 = new LaunchThread2(textcontainer.getText(),
                        text2.getText(), textpwd2.getText(), text1.getText());
                Thread t = new Thread(lch1);
                t.start();
            }
        });

        text = new Text(top, SWT.MULTI | SWT.H_SCROLL | SWT.V_SCROLL);
        text.setLayoutData(new GridData(GridData.FILL_BOTH));
    }

    public void appendText(String txt)
    {
        final String mytext = txt;
        Display.getDefault().syncExec(new Runnable()
        {
            public void run()
            {
                text.append(mytext);
                text.append("\n"); //$NON-NLS-1$
            }
        });
    }

    public class LaunchThread1 implements Runnable
    {
        protected String CONTAINER_CLIENT_NAME = "ecf.xmpp.smack"; //$NON-NLS-1$
        protected String CLIENT1 = "ecf.test1@gpn-l"; //$NON-NLS-1$
        protected String CLIENT2 = "ecf.test2@gpn-l"; //$NON-NLS-1$
        protected String PWD1 = "bot"; //$NON-NLS-1$

        public LaunchThread1(String container, String t1, String pwd1, String t2)
        {
            CLIENT1 = t1;
            CLIENT2 = t2;
            PWD1 = pwd1;
            CONTAINER_CLIENT_NAME = container;
        }

        public void testServiceXMPPServer() throws Exception
        {
            appendText("1 --->    Creation client 1"); //$NON-NLS-1$
            IContainer clientOne = ContainerFactory.getDefault()
                    .createContainer(CONTAINER_CLIENT_NAME);

            appendText("1 --->    Connexion client 1"); //$NON-NLS-1$

            ID id = IDFactory.getDefault().createID("ecf.xmpp", CLIENT1); //$NON-NLS-1$
            IConnectContext connectContext = ConnectContextFactory
                    .createPasswordConnectContext(PWD1);
            clientOne.connect(id, connectContext);

            IPresenceContainerAdapter presenceContainer = (IPresenceContainerAdapter) clientOne
                    .getAdapter(IPresenceContainerAdapter.class);

            IRosterManager rosters = presenceContainer.getRosterManager();

            appendText("1 --->    Send presence "); //$NON-NLS-1$
            Presence myPresence = new Presence(IPresence.Type.AVAILABLE,
                    "I m here, are you ?", IPresence.Mode.AVAILABLE, //$NON-NLS-1$
                    new Hashtable<String, String>(), null);

            rosters.getPresenceSender().sendPresenceUpdate(null, myPresence);

            appendText("1 --->    Use IRemoteServiceContainerAdapter 1"); //$NON-NLS-1$
            final IRemoteServiceContainerAdapter adapter = (IRemoteServiceContainerAdapter) clientOne
                    .getAdapter(IRemoteServiceContainerAdapter.class);
            appendText("1 --->    IRemoteServiceContainerAdapter 1 : " + adapter); //$NON-NLS-1$
            adapter.addRemoteServiceListener(new IRemoteServiceListener()
            {
                public void handleServiceEvent(final IRemoteServiceEvent event)
                {
                    appendText("1 --->    >>>>>>>>>>>   IRemoteServiceListener 1 " //$NON-NLS-1$
                            + event);
                    appendText("1 --->    >>>>>>>>>>>   event.getContainerID()=" //$NON-NLS-1$
                            + event.getContainerID());
                    appendText("1 --->    >>>>>>>>>>>   event.getClazzes()[0]="
                            + event.getClazzes()[0]);

                    new Thread()
                    {
                        @Override
                        public void run()
                        {
                            IRemoteCall remoteCall = new IRemoteCall()
                            {
                                public String getMethod()
                                {
                                    return "concat"; //$NON-NLS-1$
                                }

                                public Object[] getParameters()
                                {
                                    return new Object[] {
                                            "CONCATENATE TH", "IS PLEASE" }; //$NON-NLS-1$ //$NON-NLS-2$
                                }

                                public long getTimeout()
                                {
                                    return 3000;
                                }
                            };
                            try
                            {
                                String result = (String) adapter
                                        .getRemoteService(event.getReference())
                                        .callSynch(remoteCall);
                                appendText("1 --->    >>>>>>>>>>>   CALLED result='"
                                        + result + "'");
                            }
                            catch (ECFException e)
                            {
                                e.printStackTrace();
                            }
                        }
                    }.start();
                }
            });

            appendText("1 --->    --- Client 1 = " //$NON-NLS-1$
                    + IDFactory.getDefault().createStringID(CLIENT1));

            appendText("1 --->    --- IDFactory.getDefault().createID(\"ecf.xmpp\", " //$NON-NLS-1$
                    + CLIENT1 + ") = " //$NON-NLS-1$
                    + IDFactory.getDefault().createID("ecf.xmpp", CLIENT1)); //$NON-NLS-1$
            appendText("1 --->    --- clientOne.getID() = " + clientOne.getID()); //$NON-NLS-1$
            ID[] targetIds = new ID[1];
            targetIds[0] = IDFactory.getDefault().createID("ecf.xmpp", CLIENT2);
            appendText("1 --->    --- targetIds = " + targetIds[0]); //$NON-NLS-1$

            appendText("1 --->    We sleep 40 seconds before disconnection (Wait for client 2 connection)..."); //$NON-NLS-1$
            Thread.sleep(40000);

            appendText("1 --->    Disconnect 1"); //$NON-NLS-1$
            clientOne.disconnect();
            clientOne.dispose();

        }

        public void run()
        {
            try
            {
                testServiceXMPPServer();

            }
            catch (Exception e)
            {
                StringWriter sw = new StringWriter();
                PrintWriter pw = new PrintWriter(sw);
                e.printStackTrace(pw);
                appendText("1 --->    Error \n\n " + e.getMessage() + "\n" + sw.toString()); //$NON-NLS-1$
            }
            finally
            {

                appendText("1 --->   End server"); //$NON-NLS-1$
            }
        }
    }

    public class LaunchThread2 implements Runnable
    {
        protected String CONTAINER_CLIENT_NAME = "ecf.xmpp.smack"; //$NON-NLS-1$
        protected String CLIENT1 = "ecf.test1@gpn-l"; //$NON-NLS-1$
        protected String CLIENT2 = "ecf.test2@gpn-l"; //$NON-NLS-1$
        protected String PWD2 = "bot"; //$NON-NLS-1$

        public LaunchThread2(String container, String t2, String pwd2, String t1)
        {
            CLIENT1 = t1;
            CLIENT2 = t2;
            PWD2 = pwd2;
            CONTAINER_CLIENT_NAME = container;
        }

        public void testServiceXMPPServer() throws Exception
        {
            appendText("2 --->    Creation client 2"); //$NON-NLS-1$
            IContainer clientTwo = ContainerFactory.getDefault()
                    .createContainer(CONTAINER_CLIENT_NAME);

            appendText("2 --->    Connexion client 2"); //$NON-NLS-1$
            ID id2 = IDFactory.getDefault().createID("ecf.xmpp", CLIENT2); //$NON-NLS-1$
            IConnectContext connectContext2 = ConnectContextFactory
                    .createPasswordConnectContext(PWD2);
            clientTwo.connect(id2, connectContext2);

            IPresenceContainerAdapter presenceContainer = (IPresenceContainerAdapter) clientTwo
                    .getAdapter(IPresenceContainerAdapter.class);

            IRosterManager rosters = presenceContainer.getRosterManager();

            appendText("2 --->    Send presence "); //$NON-NLS-1$
            Presence myPresence = new Presence(IPresence.Type.AVAILABLE,
                    "I m here, are you ?", IPresence.Mode.AVAILABLE, //$NON-NLS-1$
                    new Hashtable<String, String>(), null);

            rosters.getPresenceSender().sendPresenceUpdate(null, myPresence);

            IRemoteServiceContainerAdapter serviceContaineradapterTwo = (IRemoteServiceContainerAdapter) clientTwo
                    .getAdapter(IRemoteServiceContainerAdapter.class);
            serviceContaineradapterTwo
                    .addRemoteServiceListener(new IRemoteServiceListener()
                    {
                        @Override
                        public void handleServiceEvent(IRemoteServiceEvent event)
                        {
                            appendText("2 --->     >>>>>>>>>>>   IRemoteServiceListener 2" + event); //$NON-NLS-1$
                        }
                    });

            ID[] targetIds = new ID[1];
            targetIds[0] = IDFactory.getDefault().createID("ecf.xmpp", CLIENT1);
            appendText("2 --->     targetIds = " + targetIds[0]); //$NON-NLS-1$

            Properties props = new RemoteServiceProperties(
                    CONTAINER_CLIENT_NAME, IDFactory.getDefault()
                            .createStringID(CLIENT1));
            props.put(Constants.SERVICE_REGISTRATION_TARGETS, targetIds);
            props.put(Constants.AUTOREGISTER_REMOTE_PROXY, "true"); //$NON-NLS-1$
            IConcatService concatService = new IConcatServiceImpl();
            appendText("2 ---> registerRemoteService= = " //$NON-NLS-1$
                    + IConcatService.class.getName());
            IRemoteServiceRegistration remoteServiceReg = serviceContaineradapterTwo
                    .registerRemoteService(new String[] { IConcatService.class
                            .getName() }, concatService, props);

            appendText("2 ---> remoteServiceReg=" + remoteServiceReg); //$NON-NLS-1$
            appendText("2 --->    We sleep 40 seconds before disconnection..."); //$NON-NLS-1$
            Thread.sleep(40000);

            appendText("2 --->    Disconnect 2"); //$NON-NLS-1$
            clientTwo.disconnect();
            clientTwo.dispose();

        }

        public void run()
        {
            try
            {
                testServiceXMPPServer();
            }
            catch (Exception e)
            {
                StringWriter sw = new StringWriter();
                PrintWriter pw = new PrintWriter(sw);
                e.printStackTrace(pw);
                appendText("2 --->    Error \n\n " + e.getMessage() + "\n" + sw.toString()); //$NON-NLS-1$
            }
            finally
            {

                appendText("2 --->    End server"); //$NON-NLS-1$
            }
        }
    }

    @Override
    public void setFocus()
    {
    }

}
